// подключение библиотек
#include <SPI.h>
#include <RF22.h>
#include <Wire.h>
#include <SHT2x.h>

// создание объекта radio
RF22 rf22;

void setup() {
  Wire.begin();
  Serial.begin(9600);
  // инициализация si4432 с настройками по умолчанию 
  if (!rf22.init())
    Serial.println("RF22 init failed");
  else
    Serial.println("RF22 init OK!!!");
}

void loop() {
    // ожидание данных
    rf22.waitAvailable();
    uint8_t buf[RF22_MAX_MESSAGE_LEN];
    uint8_t len = sizeof(buf);
    if (rf22.recv(buf, &len)) {
      // вывести полученные данные в serial
      Serial.print("get request: ");
      Serial.println((char*)buf);
      // данные для отправки ответа
      char data[] = "send answer to client";
      // запрошена температура
      if(StrContains((char*)buf,"tempSHT21")!=0)
        {
        // получение данных температуры
        Serial.print("     Temperature(C): ");       
        Serial.println(SHT2x.GetTemperature());
        dtostrf(SHT2x.GetTemperature()*10,10,0,data);
        }
      // запрошена влажность
      else if(StrContains((char*)buf,"humiditySH21")!=0)
        {
        // получение данных влажности
        Serial.print("Humidity(%RH): ");
        Serial.println(SHT2x.GetHumidity());
        dtostrf(SHT2x.GetHumidity()*10,10,0,data);
        }
      else
        {
        Serial.println("error");
        dtostrf(999,10,0,data);
        }

      // отправка ответа
      rf22.send((uint8_t*)data, sizeof(data));
      rf22.waitPacketSent();
      Serial.println("Sent a reply");
    }
    else
    {
      Serial.println("recv failed");
    }
}
// сравнение строк на идентичность
// 1 если да
// 0 - нет
char StrContains(char *str, char *sfind) {
  char found = 0;
  char index = 0;
  char len;

  len = strlen(str);

  if (strlen(sfind) > len) 
     {return 0;}
  while (index < len) 
     {
     if (str[index] == sfind[found]) 
       {
       found++;
       if (strlen(sfind) == found) 
         {return 1;}
       }
     else 
       {found = 0;}
     index++;
     }
  return 0;
}
